(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: PREVBMP.PAS                                                    *)
(*  Obsah: filtr a prevadec obrazku BMP z 24 bpp na 8 nebo 4               *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 21.9.2015                                             *)
(*  Pro kompilaci: (DOS.TPU)                                               *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program prevodnik_bmpcek;
{$I-}
uses dos;

const nejdecist='Chyba pri cteni ze souboru, nejspis je chyba na disku.';
      nejdepsat='Chyba pri zapisu do souboru, nejspis doslo misto na disku.';

type PoleBytu=array[0..767] of byte; {pomocny typ pro pristup k jednotlivym bytum bitmap}

     PaletovePole=array[0..255,1..4] of byte; {slozky v poradi B,G,R,P}

     HlavickaBMP = record
                   znacka:array[1..2] of char; {'BM'}
                   VelikostSouboru:longint; {uplne celeho}
                   rezervovano:longint; {k nicemu}
                   OfsetBitmapy:longint; {adresa prvniho bytu bitmapy, poc. od 0 od zacatku souboru}
                   end;

     HlavickaDIBv3 = record
                     VelikostHlavicky:longint; {=40}
                     _sirka, {sirka bitmapy [px]}
                     _vyska:longint; {vyska [px]}
                     PocetBitovychRovin:word; {=1 (vzdy)}
                     BituNaPixel:word; {=1, 4, 8, 16, 24 nebo 32}
                     komprese:longint; {0=zadna, 1=RLE pro 8 b/px, 2=RLE pro 4 b/px, 3=bitove pole (?), 4=JPG, 5=PNG}
                     VelikostBitmapy:longint; {=vyska * zaokrouhlena sirka (nahoru na nasobek 4)}
                     rozliseniX,rozliseniY:longint; {[px/m]}
                     PocetBarevVPalete:longint; {pocet polozek palety, 0 = vsechny podle bpp}
                     PocetPlatnychBarev:longint; {kolik barev je opravdu dulezitych, 0 = vsechny}
                     end;

var buffer1,buffer2:^polebytu;
    r,g,b:byte;
    x,y,delkaradku1,delkaradku2,delkaradku3:word;
    i,barva:integer;
    NaslaSe:boolean;
    hbmp:hlavickabmp;
    hdib3:hlavickadibv3;
    sirka,vyska:longint;
    vstup,vystup:file;
    paleta:paletovepole;
    jmenovstupu:pathstr;
    cesta:dirstr; jmeno:namestr; koncovka:extstr;
    cilovebpp:byte;
    pocetbarev:word;
    otevrenvstup,otevrenvystup:boolean;
    filtrujeme:boolean;

function alokuj(var ukazatel; velikost:longint):boolean; {vylepseny Getmem}
Begin
if (velikost>65528)or(velikost>maxavail) then alokuj:=false
                                         else begin
                                              getmem(pointer(ukazatel),velikost);
                                              alokuj:=true;
                                              end;
End;{alokuj}

function stringup(s:string):string; {prevod retezce na velka pismena}
var i:byte;
Begin
for i:=1 to length(s) do if s[i] in ['a'..'z'] then s[i]:=char(byte(s[i])-32);
stringup:=s;
End;{stringup}

procedure chyba(hlaska:string); {vypsani zpravy, pripadne zavreni otevrenych souboru, smazani vystupu a ukonceni programu}
Begin
writeln;
writeln(hlaska);
writeln;
write('Stisknete Enter...');
if otevrenvstup then begin close(vstup); if ioresult=0 then ; end;
if otevrenvystup then begin close(vystup); if ioresult=0 then ; end;
erase(vystup); if ioresult=0 then ;
readln;
halt;
End;{chyba}

procedure PrectiPaletu(odkud:string; var kam:paletovepole);
{z bmpcka Odkud (4 nebo 8 bpp) vytahne paletu a ulozi ji do promenne Kam,
pri jakekoli chybe nenapadne skonci}
var f:file;
    hbmp:hlavickabmp;
    hdib3:hlavickadibv3;
    pocetbarev:word;
    i:integer;
Begin
assign(f,odkud);
reset(f,1); if ioresult<>0 then exit;
blockread(f,hbmp,sizeof(hlavickabmp));
blockread(f,hdib3,sizeof(hdib3));
if (hbmp.znacka<>'BM')or(hdib3.velikosthlavicky<>40)or(hdib3.bitunapixel>8)
  then begin close(f); i:=ioresult; exit; end;
pocetbarev:=hdib3.pocetbarevvpalete;
if pocetbarev=0 then pocetbarev:=1 shl hdib3.bitunapixel;
blockread(f,kam,pocetbarev shl 2); i:=ioresult;
close(f); i:=ioresult;
End;{prectipaletu}

BEGIN
otevrenvstup:=false;
otevrenvystup:=false;
writeln(' --- Filtr a prevodnik 24bitovych BMP do 8 nebo 4 bitu ---');
writeln('                   (c) Mircosoft 2015');
writeln;
if paramcount=0
  then begin
       writeln(' Program slouzi k prevodu obrazku typu BMP z 24 b/px na 8 nebo 4 b/px.');
       writeln('Barvy nijak neprepocitava a zachova je presne tak, jak vypadaly ve vstupnim');
       writeln('souboru. Podminkou ovsem je, aby vstupni soubor neobsahoval vic ruznych');
       writeln('barev nez kolik se vejde do palety pri vybrane bitove hloubce (256 pri 8 bpp');
       writeln('a 16 pri 4). Podporovana je pouze hlavicka DIB verze 3 (ta nejpouzivanejsi).');
       writeln;
       writeln(' Program se ovlada pres parametry:');
       writeln('/4 - prevod do 4 bpp. Pokud tento parametr neni uveden, prevadi se do 8 bpp.');
       writeln('/F - filtr. Vsechny pixely, ktere maji nekterou slozku jinou nez 0 nebo 255,');
       writeln('     se prebarvi na bilo.');
       writeln('/P=neco.bmp - prevadeny obrazek se pokusi napasovat na paletu, kterou si');
       writeln('              vytahne z tohohle souboru.');
       writeln('Cokoli jineho se povazuje za jmeno souboru s obrazkem, ktery se ma prevest.');
       writeln;
       writeln('Priklad: PREVBMP.EXE obrazek.bmp /4 /f /p=c:\temp\paleta.bmp');
       writeln('Puvodni 24bitovy obrazek se zazalohuje pod stejnym jmenem a s koncovkou BAK.');
       writeln;
       writeln(' Ve Windows je vyhodne pridat si tenhle program k akcim u souboru typu BMP');
       writeln('a pak prevadet obrazky pohodlne dvema kliky mysi.');
       writeln;
       write('Stisknete Enter...');
       readln;
       halt;
       end;
cilovebpp:=8;
pocetbarev:=256;
jmenovstupu:='';
fillchar(paleta,sizeof(paleta),0); {vsechny nevyuzite barvy budou cerne}
for i:=1 to paramcount do
 begin
 if paramstr(i)='/4' then begin
                          cilovebpp:=4;
                          pocetbarev:=16;
                          end
  else if stringup(paramstr(i))='/F' then filtrujeme:=true
   else if copy(stringup(paramstr(i)),1,3)='/P=' then prectipaletu(copy(paramstr(i),4,255),paleta)
    else jmenovstupu:=paramstr(i);
 end;
if jmenovstupu='' then chyba('Nebyl zadan zadny soubor.');

fsplit(jmenovstupu,cesta,jmeno,koncovka);
if stringup(koncovka)<>'.BMP' then chyba('Soubor "'+jmenovstupu+'" neni BMP.');

assign(vstup,jmenovstupu); reset(vstup,1);
if ioresult<>0 then chyba('Soubor "'+jmenovstupu+'" neexistuje nebo nejde otevrit.');
otevrenvstup:=true;
assign(vystup,cesta+'VYSTUP.$$$'); rewrite(vystup,1);
if ioresult<>0 then chyba('Nelze vytvorit vystupni soubor, asi je zamceny disk.');
otevrenvystup:=true;

writeln('Pracuji...');
blockread(vstup,hbmp,sizeof(hlavickabmp));
blockread(vstup,hdib3,sizeof(hdib3));
if ioresult<>0 then chyba(nejdecist);
if hdib3.velikosthlavicky<>40
  then chyba('V souboru je hlavicka DIB jine verze nez 3, to neumim.')
  else with hdib3 do begin
                     if komprese<>0 then chyba('Komprimovane soubory cist neumim.');
                     if bitunapixel<24 then chyba('Prevadim jenom z 24 bpp.');
                     sirka:=_sirka; vyska:=_vyska;
                     end;
{buffer pro nacitani radku ze vstupniho souboru:}
delkaradku1:=3*sirka;
while (delkaradku1 and 3)<>0 do inc(delkaradku1); {zaokrouhleni nahoru na nasobek 4}
if not alokuj(buffer1,delkaradku1) then chyba('Nedostatek pameti nebo je obrazek moc siroky (zvladam maximalne 21840 px).');
{pracovni buffer pro ukladani radku v 8 bpp:}
delkaradku2:=sirka;
while (delkaradku2 and 3)<>0 do inc(delkaradku2);
if not alokuj(buffer2,delkaradku2) then chyba('Nedostatek pameti na alokaci pomocneho bufferu.');
{skutecna delka radku ve vystupnim souboru:}
delkaradku3:=(sirka*cilovebpp) shr 3 + ord((sirka*cilovebpp) and 7<>0);
while (delkaradku3 and 3)<>0 do inc(delkaradku3);
{ulozeni hlavicek:}
with hbmp do begin
             znacka:='BM';
             rezervovano:=0;
             VelikostSouboru:=sizeof(hbmp)+sizeof(hdib3)+pocetbarev shl 2+delkaradku3*vyska;
             OfsetBitmapy:=sizeof(hbmp)+sizeof(hdib3)+pocetbarev shl 2;
             end;
with hdib3 do begin
              VelikostHlavicky:=40;
              _sirka:=sirka;
              _vyska:=vyska;
              PocetBitovychRovin:=1;
              BituNaPixel:=cilovebpp;
              komprese:=0;
              VelikostBitmapy:=vyska*delkaradku3;
              rozliseniX:=0;
              rozliseniY:=0;
              PocetBarevVPalete:=pocetbarev;
              PocetPlatnychBarev:=pocetbarev;
              end;
blockwrite(vystup,hbmp,sizeof(hbmp));
blockwrite(vystup,hdib3,sizeof(hdib3));
seek(vystup,hbmp.ofsetbitmapy); {paletu zatim preskocime}
if ioresult<>0 then chyba(nejdepsat);
{najedeme na prvni volnou pozici pro ukladani novych barev
(jestli je paleta prazdna, skoncime na -1):}
i:=255;
while (i>=0)and(paleta[i,1]=0)and(paleta[i,2]=0)and(paleta[i,3]=0) do dec(i);
{vstup i vystup jsou ted na zacatku bitmapy, jde se na vlastni prevod:}
for y:=1 to vyska do
 begin
 blockread(vstup,buffer1^,delkaradku1);
 if ioresult<>0 then chyba(nejdecist);
 for x:=0 to sirka-1 do
  begin
  b:=buffer1^[3*x];
  g:=buffer1^[3*x+1];
  r:=buffer1^[3*x+2];
  if filtrujeme and ((r<>0)and(r<>255)or(g<>0)and(g<>255)or(b<>0)and(b<>255))
    then begin {vsechno, co nema vsechny slozky na nule nebo maximu, se meni na bilou}
         r:=255; g:=255; b:=255;
         end;
  naslase:=false;
  for barva:=0 to i do if (b=paleta[barva,1])and(g=paleta[barva,2])and(r=paleta[barva,3])
                         then begin {tuhle barvu uz v palete mame}
                              naslase:=true;
                              break;
                              end;
  if not naslase then begin {tuhle jsme jeste nevideli, pridame ji do palety}
                      inc(i);
                      if i>pocetbarev-1 then chyba('Barev je moc a nevejdou se do palety. Na tohle nestacim.');
                      paleta[i,1]:=b; paleta[i,2]:=g; paleta[i,3]:=r;
                      barva:=i;
                      end;
  buffer2^[x]:=barva;
  end;
 if cilovebpp=4 then asm {dodatecny prevod bufferu z 8 na 4 bpp (v Asm je to pohodlnejsi)}
                     push DS
                     mov CX,word ptr sirka
                     xor AX,AX
                     xor BX,BX
                     les DI,buffer2
                     lds SI,buffer2
                      @cyklus:
                      lodsb
                      mov BL,AL
                      shl BL,4
                      lodsb
                      and AL,15
                      or AL,BL
                      stosb
                      dec CX
                      jz @hotovo
                      dec CX
                      jnz @cyklus
                     @hotovo:
                     pop DS
                     end;
 blockwrite(vystup,buffer2^,delkaradku3);
 if ioresult<>0 then chyba(nejdepsat);
 end;
{bitmapa je hotova, ted jeste ulozit paletu:}
seek(vystup,sizeof(hbmp)+sizeof(hdib3));
blockwrite(vystup,paleta,pocetbarev shl 2);
if ioresult<>0 then chyba(nejdepsat);
{hotovo, uklid:}
freemem(buffer1,delkaradku1);
freemem(buffer2,delkaradku2);
close(vstup); otevrenvstup:=false;
close(vystup); otevrenvystup:=false;
if ioresult<>0 then {je mi to celkem jedno};
rename(vstup,cesta+jmeno+'.BAK');
if ioresult<>0 then chyba('Puvodni soubor se nepodarilo prejmenovat.');
rename(vystup,jmenovstupu);
if ioresult=0 then writeln('Prevod uspesne dokoncen.')
              else begin {ted uz vystup mazat nechceme, tak to musime rozepsat}
                   writeln;
                   writeln('Vystupni soubor se nepodarilo spravne prejmenovat,'#13#10+
                           'vysledek najdete v souboru '+cesta+'VYSTUP.$$$.');
                   writeln;
                   write('Stisknete Enter...');
                   readln;
                   end;
END.